#ifndef PTR_ISOMME_H
#define PTR_ISOMME_H

struct ISomme;

class ErreurCreation {};
class ErreurInvocation {};

#include <string>

class ptrISomme
{
   mutable ISomme *ptr_;
public:
   void swap(ptrISomme &);
   ptrISomme(const std::wstring &adresse = L"127.0.0.1"); // throw(ErreurCreation);
   ptrISomme(const ptrISomme&);
   ptrISomme& operator=(const ptrISomme&);
   ~ptrISomme() throw();
   int Somme(const int x, const int y); // throw(ErreurInvocation);
};

#endif
