#ifndef FABRIQUE_SOMME_H
#define FABRIQUE_SOMME_H

#include "IClassFactoryImpl.h"

class FabriqueSomme
   : public IClassFactoryImpl
{
public:
   using IClassFactoryImpl::AddRef;
   using IClassFactoryImpl::Release;
   HRESULT __stdcall QueryInterface(REFIID riid, void **ppv)
   {
      if (riid == IID_IUnknown)
         *ppv = static_cast<IUnknown*>(this);
      else if (riid == IID_IClassFactory)
         *ppv = static_cast<IClassFactory*>(this);
      else
      {
         *ppv = 0;
         return E_NOINTERFACE;
      }
      AddRef();
      return S_OK;
   }
   HRESULT __stdcall CreateInstance
      (IUnknown *pUnkOuter, REFIID riid, void **ppv);
};

#endif
