#include "GestionnaireDeVerrou.h"
#include "Mutex.h"
// Dfinition du singleton
GestionnaireDeVerrou GestionnaireDeVerrou::singleton;
// Constructeur
GestionnaireDeVerrou::GestionnaireDeVerrou() throw()
   : cptobj_(0), fin_((Evenement::ReinitialisationManuelle()))
{
}
// Oprations scurises sur le verrou
void GestionnaireDeVerrou::incrementer() throw()
{
   Autoverrou av(mutex_);
   ++cptobj_;
}
void GestionnaireDeVerrou::decrementer() throw()
{
   Autoverrou av(mutex_);
   if (--cptobj_ == 0)
      fin_.provoquer();
}
// Consultation du verrou
bool GestionnaireDeVerrou::est_vide() const throw()
   { return cptobj_ == 0; }
