#ifndef STD_CREATE_INSTANCE_H
#define STD_CREATE_INSTANCE_H
#include <unknwn.h>
template <class T>
   HRESULT StdCreateInstance
      (IUnknown *pUnkOuter, REFIID riid, void **ppv)
   {
      if (pUnkOuter) // rejet de tout pUnkOuter non nul
         return CLASS_E_NOAGGREGATION;
      try
      {
         // Instanciation du composant
         T *p = new T;
         // Interrogation de l'identit du composant
         HRESULT hr = p->QueryInterface(riid, ppv);
         p->Release();
         return hr;
      }
      catch (...)
         { } // erreur lors du new
      return E_OUTOFMEMORY;
   }
#endif
